var args = arguments[0] || {};

var acs = require('ACS');

var accounting = require('accounting');

var approverSet=false;
var prioritySet=false;

function isValidForm() {
	Ti.API.debug("addApproval: isValidForm");
	
	if(($.appTitleTF.value==="") || ($.appAmountTF.value==="") || !prioritySet || !approverSet || ($.appDetailsTA.value==="")) {
		return false;
	} else {
		return true;	
	}
}

function activityInidcatorHide() {
	Ti.API.debug("addApproval: activityInidcatorHide()");
	
	$.activityIndicator.hide();
	if(OS_IOS) {
		$.activityIndicatorVw.visible=false;
	}
}

function activityInidcatorShow() {
	Ti.API.debug("addApproval: activityInidcatorShow()");
	
	if(OS_IOS) {
		$.activityIndicatorVw.visible=true;	
	}
	$.activityIndicator.show();
}

function addApprovalCancel() {
	Ti.API.debug("addApproval: addApprovalCancel");
	
	Alloy.Globals.Breadcrumb_AnalyticEvent('app.feature.addApproval.cancel',{});
	
	var dialog = Ti.UI.createAlertDialog({
		cancel: 1,
		buttonNames: ['Yes','No'],
		message: "Are you sure you want to cancel and lose any entered information?",
		title: "Cancel"
	});
	dialog.addEventListener('click', function(e){
		Ti.API.debug("addApproval: cancelAlertDialog click event fired, e.index = "+e.index);
	    if(e.index == 0) {
	    		$.addApproval.close();
	    }
	});
	dialog.show();	
}

function blurAll() {
	$.appTitleTF.blur();
	$.appAmountTF.blur();
	$.appDetailsTA.blur();
}

$.approverSelectTVR.addEventListener('click', function(e){
	Ti.API.debug("addApproval: approverSelectTVR click event");
	
	blurAll();
	
	// Extract usernames
	var username = [];
	_.each(Alloy.Globals.allUsers, function(item) {
		if(item.username != Alloy.Globals.username) { // remove yourself from list
			username.push(item.username);	
		}
	});
	
	// Sort usernames alphabetically
	username.sort();
	
	Ti.API.debug("username = "+username);
	
	// Put usernames in key/value format that danielhanold.pickerWidget requires
	var userListArray = [];
	var userListArrayObj = {};
	var i = 1; //key should not be 0
	for(var i=1;i<=username.length;i++){
		userListArrayObj[parseInt(i)] = username[i-1];
	}
	userListArray.push(userListArrayObj);
	
	Ti.API.debug("userListArray = "+JSON.stringify(userListArray));
	
	Alloy.createWidget('danielhanold.pickerWidget', {
		id: 'mySingleColumn',
		outerView: $.addApproval,
		hideNavBar: false,
		type: 'single-column',
		selectedValues: [1],
		// pickerValues: [{10: 'Auburn', 20: 'Bald', 30: 'Black'}],
		pickerValues: userListArray,
		onDone: function(e) {
		  e = e || {};
		  Ti.API.debug(JSON.stringify(e));
		  if (e.cancel === true) {
		    Ti.API.debug('Entry was cancelled');
		    return;
		  }
		  approverSet = true;
		  $.approverLBL.text = e.data[0].value;
		}
	});
});

$.prioritySelectTVR.addEventListener('click', function(e){
	Ti.API.debug("addApproval: prioritySelectTVR click event");
	
	blurAll();
	
	Alloy.createWidget('danielhanold.pickerWidget', {
		id: 'mySingleColumn',
		outerView: $.addApproval,
		hideNavBar: false,
		type: 'single-column',
		selectedValues: [1],
		pickerValues: [{1: 'Low', 2: 'Medium', 3: 'High'}],
		onDone: function(e) {
		  e = e || {};
		  Ti.API.debug(JSON.stringify(e));
		  if (e.cancel === true) {
		    Ti.API.debug('Entry was cancelled');
		    return;
		  }
		  prioritySet = true;
		  $.priorityLBL.text = e.data[0].value;
		}
	});
});

function addApprovalSubmit() {
	Ti.API.debug("addApproval: addApprovalSubmit");
	
	var approver = $.approverLBL.text;
	
	if(isValidForm()) {
		activityInidcatorShow();
		acs.ACSCreateApproval($.appTitleTF.value, $.appAmountTF.value, $.priorityLBL.text, approver, $.appDetailsTA.value, {
			error: function(e) {
				Alloy.Globals.Breadcrumb_AnalyticEvent('app.feature.addApproval.submitError',{});
				activityInidcatorHide();
				Ti.API.debug(e);
			},
			success: function(e) {
				Alloy.Globals.Breadcrumb_AnalyticEvent('app.feature.addApproval.submitSuccess',{});
				activityInidcatorHide();
				Ti.API.debug(e);
				// if(OS_IOS){Alloy.Globals.refreshApprovalsList();};
				notifyUser(approver,"Approval request has been assigned to you");
				$.addApproval.close();
			}
		});
	} else {
		alert("Enter all fields before submitting approval");
		Alloy.Globals.Breadcrumb_AnalyticEvent('app.feature.addApproval.invalidForm',{});
	}
}

$.appAmountTF.addEventListener('change', function(e){
	Ti.API.debug("addApproval: appAmountTF change event");
	
	// $.appAmountTF.value =  accounting.formatMoney($.appAmountTF.value,'$',0);
});

function notifyUser(username, msg) {
	Ti.API.debug("addApproval: notifyUser()");

	acs.ACSSendPush(username, msg, {
		success: function(e) {
			Ti.API.debug(e);
		},
		error: function(e) {
			Ti.API.debug(e);
		}
	});	
}

Alloy.Globals.Breadcrumb_AnalyticEvent('app.feature.addApproval.open',{});